module React
  module Window

    [ # Properties
      :closed, :console, :controllers, :crypto, :devicePixelRatio,
      :dialogArguments, :document, :frameElement, :frames, :fullscreen,
      :history, :indexedDB, :innerHeight, :innerWidth, :isSecureContext,
      :length, :localStorage, :location, :locationbar, :menubar, 
      :messageManager, :name, :navigator, :opener, :outerHeight, :outerWidth,
      :parent, :performance, :personalbar, :screen, :screenX, :screenY, 
      :scrollbars, :scrollX, :scrollY, :sessionStorage, :status, :statusbar,
      :toolbar, :top, :URL, :window,
    ].each { |key| define_method(key){ $$.window[key] } }

    [ # Methods
      :alert, :atob, :blur, :btoa, :cancelAnimationFrame, :cancelIdleCallback,
      :clearImmediate, :clearInterval, :clearTimeout, :close, :confirm, 
      :convertPointFromNodeToPage, :createImageBitmap, :fetch, :focus, 
      :forward, :getAttention, :getComputedStyle, :getDefaultComputedStyle,
      :getSelection, :home, :matchMedia, :minimize, :moveBy, :moveTo, :open,
      :postMessage, :prompt, :requestAnimationFrame, :requestIdleCallback, 
      :resizeBy, :resizeTo, :restore, :scroll, :scrollBy, :scrollByPages, 
      :scrollTo, :setInterval, :setImmediate, :setTimeout, :sizeToContent, 
      :stop, :updateCommands 
    ].each { |key| 
      define_method(key) { |*args, &block|
        $$.window[key].call(*args, &block)
    }}

  end
end